/*********************************************
Project : PPE Dtection d'Obstacle (Commande d'un moteur pas  pas)
Version : 1
Date    : 02/2004
Author  : Jonet - Labonne               
Company : LYCEE Pierre Emile MARTIN       
Comments: Commande d'un moteur pas  pas aprs avoir rgl
          le sens de dplacement(Horaire, Hanti horaire et
          le nombre de pas ( 12 max)
Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>

// Librairies non gnres par Wizard (rajoutes manuellement)      
#include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD,Regdebit,Select_Seringue 
#include <delay.h>    // contient la fonction delay_ms
#include <stdio.h>    // contient la fonction sprintf

// Etats du graphe des transitions "Menu"
#define Reglage	 	0
#define Marche	 	1
#define ReglagePas	2    
#define ChoixSens	3

// Code des BPs de la carte AT90S8535 SSI
#define INC		0x1F
#define DEC		0x2F
#define OK		0x37
#define ECHAP		0x3B
#define SET		0x3D
#define ENTR		0x3E

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>  

// Prototypes des fonctions
unsigned char droite(void);  // rotation  droite
unsigned char gauche(void);  // rotation  gauche


//--------------------
// Programme principal
//--------------------

void main(void)
{
// Declare your local variables here
//----------------------------------
char display_buffer_ligne0[17]; // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; // tampon ligne 1 de l'afficheur
unsigned char etat = Reglage, etat_1 = Marche; // variables du graphe Menu
unsigned char BP; // BP = code ou tat de la touche slectionne			    
unsigned char Npas=0, Npas_1,sens=1; 

// Input/Output Ports initialization
// Port A
PORTA=0x3F;
DDRA=0x00;

// Port B
PORTB=0x00;      		       			
DDRB=0x1f;

// LCD module initialization
lcd_init(16);

while (1)
  {
      BP = Lire_BP();
      
      switch (etat)
      {
       case Reglage : if (etat_1 != etat)
                       {
                        PORTB = 0x00;  // dsactivation du moteur
                        sprintf(display_buffer_ligne0,"OK>PAS ENTR>SENS");
                    	sprintf(display_buffer_ligne1,"SET -> RUN");
                    	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                       }
                       if (BP==OK) etat = ReglagePas;
                      		else if (BP==SET) etat = Marche;
                      	       		else if (BP==ENTR) etat = ChoixSens;
                      		               else etat = Reglage;
       		       etat_1 = Reglage; 
       break;
       		   
       case Marche :     if (sens==0) sprintf(display_buffer_ligne0,"Horaire");
       				else sprintf(display_buffer_ligne0,"Anti horaire");
                    	 sprintf(display_buffer_ligne1,"PAS=%d",Npas);
                    	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                         
                         if (sens==1)
                                {
       				  while (Npas!=0)
	    		              {
	    		                PORTB=droite();
	     				Npas=Npas-1;
	   			      } 
				}
    			     else  
   				{ 
   			         while (Npas!=0)
	   			      {
	    		                PORTB=gauche();
	    		                Npas=Npas-1;
	   			      }
	   			 }                          
                       delay_ms(1500); 
       		       etat = Reglage;
                       etat_1 = Marche;
       break;
                      
       case ReglagePas:  if (Npas==-1) Npas = 12;
  				else if (Npas > 12) Npas = 0; 
  				
   		         if ((Npas_1 != Npas) || (etat_1 != etat))
     			  {
      			   sprintf(display_buffer_ligne0,"INC/DEC -> +/-");
      		           sprintf(display_buffer_ligne1,"%-u pas ECHP->FIN",Npas);
      			   Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
      			   Npas_1 = Npas;
     			  }
     			 switch(BP)
     		          {
      			    case INC   : Npas = Npas + 1; break;
      			    case DEC   : Npas = Npas - 1; break;
      			    case ECHAP : etat = Reglage;
     		          }
                        etat_1 = ReglagePas;
       break;
       
       case ChoixSens: if (etat_1 != etat)
                            {
                            sprintf(display_buffer_ligne0,"DEC->AH, INC->H");
                            sprintf(display_buffer_ligne1,"ECHAP -> FIN");
                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 	
                            } 
                            if (BP==ECHAP) etat = Reglage;
                                         else if (BP==DEC) {sens = 1; etat = Reglage;}
                                              else if (BP==INC) {sens = 0; etat = Reglage;}
                      		              		else etat = ChoixSens;
                            etat_1 = ChoixSens;
       break;
      } // fin du switch
   } // fin du while
} // fin du prog principal


//Sous programme sens(droite)
unsigned char droite(void)
{
static unsigned char pas=1; 
unsigned char Moteur;
 
  switch (pas)
  {   
       case 1 : Moteur=5 ; delay_ms(500) ;pas=2 ; break ;
       case 2 : Moteur=6 ; delay_ms(500) ;pas=3 ; break ;
       case 3 : Moteur=10 ; delay_ms(500);pas=4 ; break ;
       case 4 : Moteur=9 ; delay_ms(500) ;pas=1 ; break ;            
  }
  return Moteur;
} //fin Sous programme sens(droite)


//Sous programme sens(gauche)
unsigned char gauche(void)                        
{
static unsigned char pas=1;  
unsigned char Moteur;

  switch (pas)
  {     
       case 1 : Moteur=9 ; delay_ms(500) ;pas=2 ; break ;
       case 2 : Moteur=10 ; delay_ms(500);pas=3 ; break ;
       case 3 : Moteur=6 ; delay_ms(500) ;pas=4 ; break ;
       case 4 : Moteur=5 ; delay_ms(500) ;pas=1 ; break ;
  }
  return Moteur;    
} //fin Sous programme sens(gauche)                   


